------------------------------------------------------
-- Written by Saur of Emerald Dream, EU.
-- Edited by Ibori of Emerald Dream, EU.
-- A lot of code was borrowed from Fizzwidget Disenchant Predictor by Gazmik Fizzwidget
------------------------------------------------------

local THDKP_RecipeValue = {
	[2] = 5;	-- Uncommon
	[3] = 10;	-- Rare
	[4] = 15;	-- Epic
}

local THDKP_ItemValue = {
	[3] = 0.25;	-- Rare
	[4] = 1;	-- Epic
	[5] = 2;	-- Legendary
}

local THDKP_SlotValue = {
	["INVTYPE_2HWEAPON"] = 2.5;

	["INVTYPE_WEAPON"] = 1.5;
	["INVTYPE_WEAPONMAINHAND"] = 1.5;
	["INVTYPE_WEAPONOFFHAND"] = 1.0;
	["INVTYPE_RANGED"] = 2.0;
	["INVTYPE_THROWN"] = 0.75;
	["INVTYPE_SHIELD"] = 1.5;
	["INVTYPE_HOLDABLE"] = 1.0;	-- Held In Off-hand

	["INVTYPE_HEAD"] = 1.75;
	["INVTYPE_CHEST"] = 1.75;
	["INVTYPE_ROBE"] = 1.75;	-- Chest
	["INVTYPE_LEGS"] = 1.75;

	["INVTYPE_SHOULDER"] = 1.5;
	["INVTYPE_FEET"] = 1.5;

	["INVTYPE_HAND"] = 1.35;
	["INVTYPE_WAIST"] = 1.35;

	["INVTYPE_CLOAK"] = 1.15;
	["INVTYPE_WRIST"] = 1.0;

	["INVTYPE_NECK"] = 1;
	["INVTYPE_FINGER"] = 1;
	["INVTYPE_TRINKET"] = 1;
	["INVTYPE_RANGEDRIGHT"] = 0.75;	-- Wand
	["INVTYPE_RELIC"] = 0.75;	-- Libram, Idol, Totem

--	["INVTYPE_AMMO"] = nil;
--	["INVTYPE_BAG"] = nil;
--	["INVTYPE_BODY"] = nil;		-- Shirt
--	["INVTYPE_TABARD"] = nil;
}

local THDKP_ItemID2Value = {
	-- Tier 4 tokens
	[29753]	= 62.5;		-- Chestguard of the Fallen Hero (Hunter, Mage, Warlock)
	[29754]	= 62.5;		-- Chestguard of the Fallen Champion (Paladin, Rogue, Shaman)
	[29755]	= 62.5;		-- Chestguard of the Fallen Defender (Warrior, Priest, Druid)
	[29756]	= 50;		-- Gloves of the Fallen Hero (Hunter, Mage, Warlock)
	[29757]	= 50;		-- Gloves of the Fallen Champion (Paladin, Rogue, Shaman)
	[29758]	= 50;		-- Gloves of the Fallen Defender (Warrior, Priest, Druid)
	[29759]	= 62.5;		-- Helm of the Fallen Hero (Hunter, Mage, Warlock)
	[29760]	= 62.5;		-- Helm of the Fallen Champion (Paladin, Rogue, Shaman)
	[29761]	= 62.5;		-- Helm of the Fallen Defender (Warrior, Priest, Druid)
	[29762]	= 57.5;		-- Pauldrons of the Fallen Hero (Hunter, Mage, Warlock)
	[29763]	= 57.5;		-- Pauldrons of the Fallen Champion (Paladin, Rogue, Shaman)
	[29764]	= 57.5;		-- Pauldrons of the Fallen Defender (Warrior, Priest, Druid)
	[29765]	= 57.5;		-- Leggings of the Fallen Hero (Hunter, Mage, Warlock)
	[29766]	= 57.5;		-- Leggings of the Fallen Champion (Paladin, Rogue, Shaman)
	[29767]	= 57.5;		-- Leggings of the Fallen Defender (Warrior, Priest, Druid)

	-- Tier 5 tokens
	[30236]	= 69;		-- Chestguard of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30237]	= 69;		-- Chestguard of the Vanquished Defender (Warrior, Priest, Druid)
	[30238]	= 69;		-- Chestguard of the Vanquished Hero (Hunter, Mage, Warlock)
	[30239]	= 53;		-- Gloves of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30240]	= 53;		-- Gloves of the Vanquished Defender (Warrior, Priest, Druid)
	[30241]	= 53;		-- Gloves of the Vanquished Hero (Hunter, Mage, Warlock)
	[30242]	= 69;		-- Helm of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30243]	= 69;		-- Helm of the Vanquished Defender (Warrior, Priest, Druid)
	[30244]	= 69;		-- Helm of the Vanquished Hero (Hunter, Mage, Warlock)
	[30245]	= 69;		-- Leggings of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30246]	= 69;		-- Leggings of the Vanquished Defender (Warrior, Priest, Druid)
	[30247]	= 69;		-- Leggings of the Vanquished Hero (Hunter, Mage, Warlock)
	[30248]	= 72.45;	-- Pauldrons of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30249]	= 72.45;	-- Pauldrons of the Vanquished Defender (Warrior, Priest, Druid)
	[30250]	= 72.45;	-- Pauldrons of the Vanquished Hero (Hunter, Mage, Warlock)

	-- Tier 6 tokens
	[31089]	= 78;		-- Chestguard of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[31090]	= 78;		-- Chestguard of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[31091]	= 78;		-- Chestguard of the Forgotten Protector (Warrior, Hunter, Shaman)
	[31092]	= 60;		-- Gloves of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[31093]	= 60;		-- Gloves of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[31094]	= 60;		-- Gloves of the Forgotten Protector (Warrior, Hunter, Shaman)
	[31095]	= 78;		-- Helm of the Forgotten Protector (Warrior, Hunter, Shaman)
	[31096]	= 78;		-- Helm of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[31097]	= 78;		-- Helm of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[31098]	= 78;		-- Leggings of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[31099]	= 78;		-- Leggings of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[31100]	= 78;		-- Leggings of the Forgotten Protector (Warrior, Hunter, Shaman)
	[31101]	= 67;		-- Pauldrons of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[31102]	= 67;		-- Pauldrons of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[31103]	= 67;		-- Pauldrons of the Forgotten Protector (Warrior, Hunter, Shaman)
	[34848]	= 48;		-- Bracers of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[34851]	= 48;		-- Bracers of the Forgotten Protector (Warrior, Hunter, Shaman)
	[34852]	= 48;		-- Bracers of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[34853]	= 64;		-- Belt of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[34854]	= 64;		-- Belt of the Forgotten Protector (Warrior, Hunter, Shaman)
	[34855]	= 64;		-- Belt of the Forgotten Vanquisher (Rogue, Mage, Druid)
	[34856]	= 71;		-- Boots of the Forgotten Conqueror (Paladin, Priest, Warlock)
	[34857]	= 71;		-- Boots of the Forgotten Protector (Warrior, Hunter, Shaman)
	[34858]	= 71;		-- Boots of the Forgotten Vanquisher (Rogue, Mage, Druid)
}

local THDKP_FONT_COLOR = { r=1, g=0.25, b=0.25 };

local THDKP_TooltipHooks = {};

function THDKP_GameTooltip_OnHide()
	local tooltipName = this:GetName();
	THDKP_SetTooltipHooks(tooltipName);
end

function THDKP_GameTooltip_SetDefaultAnchor(tooltip, parent)
	local tooltipName = tooltip:GetName();
	THDKP_SetTooltipHooks(tooltipName);
end

function THDKP_SetTooltipHooks(tooltipName)
	if not tooltipName or tooltipName == "" then 
		return; 
	end
	
	local tooltip = getglobal(tooltipName);
	if tooltip and tooltip:HasScript("OnTooltipSetItem") and not THDKP_TooltipHooks[tooltipName] then
		THDKP_TooltipHooks[tooltipName] = {};
		THDKP_TooltipHooks[tooltipName].OnTooltipSetItem = tooltip:GetScript("OnTooltipSetItem");
		tooltip:SetScript("OnTooltipSetItem", THDKP_OnTooltipSetItem);
	end
end

function THDKP_OnTooltipSetItem()
	local tooltipName = this:GetName();
	local tooltip = getglobal(tooltipName);

	if THDKP_TooltipHooks[tooltipName] and THDKP_TooltipHooks[tooltipName].OnTooltipSetItem then
		THDKP_TooltipHooks[tooltipName].OnTooltipSetItem(tooltip);
	end

	local name, link = this:GetItem();

	if link then
		-- workaround for OnTooltipSetItem being called twice for recipes
		local _, _, _, _, _, itemType, _, _, _, _ = GetItemInfo(link);
		if itemType == "Recipe" and this.thdkpLastLink ~= link then
			for i = 1, this:NumLines() do
				local line = getglobal(this:GetName() .. "TextLeft" .. i);
				local text = line:GetText();
				if text and string.sub(text, 1, 1) == "\n" then
					this.thdkpLastLink = link;
					return;
				end
			end
		end
		this.thdkpLastLink = nil;

		local thdkpValue, equipLoc = THDKP_Value(link);
		if thdkpValue then
			this:AddLine("TH DKP value: " .. thdkpValue, THDKP_FONT_COLOR.r, THDKP_FONT_COLOR.g, THDKP_FONT_COLOR.b);
		end
	end

	return false;
end

function THDKP_OnLoad()
	hooksecurefunc("GameTooltip_OnHide", THDKP_GameTooltip_OnHide);
	hooksecurefunc("GameTooltip_SetDefaultAnchor", THDKP_GameTooltip_SetDefaultAnchor);
	THDKP_SetTooltipHooks("GameTooltip");
	THDKP_SetTooltipHooks("ItemRefTooltip");
	THDKP_SetTooltipHooks("ShoppingTooltip1");
	THDKP_SetTooltipHooks("ShoppingTooltip2");

	local version = GetAddOnMetadata("ThDkp", "Version");
	DEFAULT_CHAT_FRAME:AddMessage("ThDkp " .. version .. " initialized!", THDKP_FONT_COLOR.r, THDKP_FONT_COLOR.g, THDKP_FONT_COLOR.b);
end

function THDKP_Value(itemLink)
	local _, _, itemID = string.find(itemLink, "item:(%d+)");
	itemID = tonumber(itemID);
	if itemID == nil then 
		return nil; 
	end

	if THDKP_ItemID2Value[itemID] then
		return THDKP_ItemID2Value[itemID];
	end

	local name, link, quality, itemLevel, minLevel, type, subType, stackCount, equipLoc, texture = GetItemInfo(itemID);	
	
	if type == "Recipe" then
		return THDKP_RecipeValue[quality];
	elseif type == "Weapon" and (subType == "Crossbows" or subType == "Guns") then
		equipLoc = "INVTYPE_RANGED";
	end
	
	if not THDKP_ItemValue[quality] or not THDKP_SlotValue[equipLoc] then
		return nil;
	end

	if minLevel <= 0 then -- Added so rewards will show as lvl 70
		minLevel = 70;
	end

	local levelDiff = itemLevel - minLevel/2;
	if levelDiff <= 0 then
		levelDiff = 1;
	end

	return THDKP_Round(levelDiff * THDKP_ItemValue[quality] * THDKP_SlotValue[equipLoc] * 0.4);
end

function THDKP_Round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

------------------------------------------------------
-- Runtime loading
------------------------------------------------------

THDKP_OnLoad();